
// GPSReceiverDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GPSReceiver.h"
#include "GPSReceiverDlg.h"

#include "SerialPort.h"
#include "NMEAParser.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CSerialPort _rc;
CNMEAParser _nmeap;

// CGPSReceiverDlg dialog

CGPSReceiverDlg::CGPSReceiverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGPSReceiverDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGPSReceiverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGPSReceiverDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CGPSReceiverDlg message handlers

BOOL CGPSReceiverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	_rc.Open ("\\\\.\\COM7", CBR_115200, 8, ONESTOPBIT, NOPARITY);
	_rc.SetTimeout (10, 10, 10);

	SetTimer (1000, 100, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGPSReceiverDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGPSReceiverDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CGPSReceiverDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	_rc.Close ();
}

void CGPSReceiverDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	char buff[4096+1];
	int len = 0;
	
	// Read GPS data
	int n = _rc.Read (&buff[len], 4096-len);
	while (0 < n) {
		len += n;

		if (2 < n && buff[len-2] == '\r' && buff[len-1] == '\n') {
			break;
		}
		n = _rc.Read (&buff[len], 4096-len);
	}

	if (0 < len) {
		//  ü ͸ ȭ鿡 ǥѴ.
		buff[len] = 0;
		SetDlgItemText (IDC_EDIT1, buff);

		// GPS  ͸ NMEA ļ мѴ.
		_nmeap.ParseBuffer (buff, len);

		// ð ǥѴ.
		char text[1024];
		sprintf (text, "%.3f", _nmeap._GGAHour*60.*60. + _nmeap._GGAMinute*60. + _nmeap._GGASecond);
		SetDlgItemText (IDC_EDIT2, text);
		
		// , 浵,  ǥѴ.
		// GPS ǥ WGS84 Ÿü  , 浵 
		sprintf (text, "%.6f deg, %.6f deg, %.3f m", _nmeap._GGALatitude, _nmeap._GGALongitude, _nmeap._GGAAltitude);
		SetDlgItemText (IDC_EDIT3, text);

		const char *gpsQualityStr[] = {
			"0-Invalid",
			"1-Valid SPS",
			"2-Valid DGPS",
			"3-Valid PPS",
			"" };
		
		// GPS ¸ ǥѴ.
		if (0 <= _nmeap._GGAGPSQuality && _nmeap._GGAGPSQuality <= 3) {
			sprintf (text, "%s, %d, %.1f", gpsQualityStr[_nmeap._GGAGPSQuality], (int)_nmeap._GGANumOfSatsInUse, _nmeap._GGAHDOP);
			SetDlgItemText (IDC_EDIT4, text);
		}

		// ̵ ӵ  ǥѴ.
		sprintf (text, "%6.0f deg, %6.3f Km/h", _nmeap._TrueCourse, _nmeap._Km);
		SetDlgItemText (IDC_EDIT5, text);

		extern void Bessel2TM (double alt, double lon, double lat, double lonOrg, double latOrg, double *tm_x, double *tm_y);

		// 츮 TM(Transverse Mercator) ǥ   
		// ߺ : 38, 127
		// x- :  ,  +
		// y- :  ,  +
		double x, y;
		Bessel2TM (_nmeap._GGAAltitude, _nmeap._GGALongitude, _nmeap._GGALatitude, 127, 38, &x, &y);

		sprintf (text, "%6.0f m, %6.0f m", x, y);
		SetDlgItemText (IDC_EDIT6, text);

		/*
		FILE *fp = fopen ("gps_log.txt", "at");
		if (fp) {
			fprintf (fp, "%10.3f,	%.6f,	%.6f,	%.3f,	%d,	%10.3f,	%10.3f\n", 
				_nmeap._GGAHour*60.*60. + _nmeap._GGAMinute*60. + _nmeap._GGASecond, 
				_nmeap._GGALatitude, _nmeap._GGALongitude, _nmeap._GGAAltitude,
				(int)_nmeap._GGANumOfSatsInUse,
				x, y);

			fclose (fp);
		}
		*/
	}

	CDialog::OnTimer(nIDEvent);
}

